
function vexalarm.frames.create()
	for key,val in pairs(vexalarm.frames.createdFrames) do
		if vexalarm_SV_frame[key] == nil then
			val:Hide()
			vexalarm.frames.createdFrames[key] = nil
		end
	end
	
	for key in pairs(vexalarm_SV_frame) do
		if vexalarm.frames.createdFrames[key] == nil then
			vexalarm.frames.createdFrames[key] = CreateFrame("Frame", nil, UIparent)
			
			vexalarm.proclaims[key] = {}
			vexalarm.proclaimPlaces[key] = {}
			
			vexalarm.totemsPlaced[key] = {}
		end
		vexalarm.frames.set(key)
		
	end
end

function vexalarm.frames.set(frame)
	vexalarm.frames.createdFrames[frame]:SetWidth(vexalarm_SV_frame[frame]["design"]["size"]["width"])
	vexalarm.frames.createdFrames[frame]:SetHeight(vexalarm_SV_frame[frame]["design"]["size"]["height"])
	
	vexalarm.frames.createdFrames[frame]:SetFrameStrata("LOW")
	vexalarm.frames.createdFrames[frame]:SetPoint(
		vexalarm_SV_frame[frame]["design"]["position"]["frame"]["frameanchor"],
		UIParent,
		vexalarm_SV_frame[frame]["design"]["position"]["frame"]["anchor"],
		vexalarm_SV_frame[frame]["design"]["position"]["frame"]["x"],
		vexalarm_SV_frame[frame]["design"]["position"]["frame"]["y"])
		
	vexalarm.frames.createdFrames[frame]:SetBackdrop({
		bgFile=vexalarm.LSM:Fetch("background", vexalarm_SV_frame[frame]["design"]["bg"]["texture"]),
		edgeFile=vexalarm.LSM:Fetch("border", vexalarm_SV_frame[frame]["design"]["border"]["texture"]),
		tile=false,
		edgeSize=vexalarm_SV_frame[frame]["design"]["border"]["size"]})
	
	if (vexalarm.testmode.activated and vexalarm.testmode.recolor) or not(vexalarm.testmode.activated) or vexalarm_Testmode_newBGcolors[frame]==nil then
		vexalarm.frames.createdFrames[frame]:SetBackdropColor(
			vexalarm_SV_frame[frame]["design"]["bg"]["color"]["r"],
			vexalarm_SV_frame[frame]["design"]["bg"]["color"]["g"],
			vexalarm_SV_frame[frame]["design"]["bg"]["color"]["b"],
			vexalarm_SV_frame[frame]["design"]["bg"]["color"]["a"])
			
		vexalarm.frames.createdFrames[frame]:SetBackdropBorderColor(
			vexalarm_SV_frame[frame]["design"]["border"]["color"]["r"],
			vexalarm_SV_frame[frame]["design"]["border"]["color"]["g"],
			vexalarm_SV_frame[frame]["design"]["border"]["color"]["b"],
			vexalarm_SV_frame[frame]["design"]["border"]["color"]["a"])
	else
		vexalarm.frames.createdFrames[frame]:SetBackdropColor(
			vexalarm_Testmode_newBGcolors[frame]["bg"][1],
			vexalarm_Testmode_newBGcolors[frame]["bg"][2],
			vexalarm_Testmode_newBGcolors[frame]["bg"][3], 0.5)
			
		vexalarm.frames.createdFrames[frame]:SetBackdropBorderColor(
			vexalarm_Testmode_newBGcolors[frame]["border"][1],
			vexalarm_Testmode_newBGcolors[frame]["border"][2],
			vexalarm_Testmode_newBGcolors[frame]["border"][3], 0.5)
	end
	vexalarm.frames.createdFrames[frame]:RegisterForDrag("LeftButton")
	vexalarm.frames.createdFrames[frame]:SetScript("OnDragStart", function () vexalarm.frames[frame]:StartMoving() end)
	vexalarm.frames.createdFrames[frame]:SetScript("OnDragStop", function (self)
		self:StopMovingOrSizing()
		vexalarm.frames.createdFrames.savePos(frame)
		end)
end

function vexalarm.frames.toggleMovable(val)
	for key in pairs(vexalarm.frames.createdFrames) do
		if vexalarm.frames.createdFrames[key] ~= nil then
			vexalarm.frames.createdFrames[key]:SetMovable(val)
			vexalarm.frames.createdFrames[key]:EnableMouse(val)
		end
	end
end

function vexalarm.frames.savePos(frame)
	if vexalarm_SV_frame[frame]~= nil then
		vexalarm_SV_frame[frame]["design"]["position"]["frame"]["frameanchor"] = select(1, vexalarm.frames.createdFrames[frame]:GetPoint())
		vexalarm_SV_frame[frame]["design"]["position"]["frame"]["anchor"] = select(3, vexalarm.frames.createdFrames[frame]:GetPoint())
		vexalarm_SV_frame[frame]["design"]["position"]["frame"]["x"] = select(4, vexalarm.frames.createdFrames[frame]:GetPoint())
		vexalarm_SV_frame[frame]["design"]["position"]["frame"]["y"] = select(5, vexalarm.frames.createdFrames[frame]:GetPoint())
	end
end