function vexalarm.rw.handler(spellname, spellid, caster, target, status, eventchar)
	if vexalarm.warning.checkOwnGrp(caster, nil, true) and vexalarm.warning.checkInfight(nil, true) and vexalarm_SV_rw["activate"] then
		if status or (not(status) and not(vexalarm_SV_rw["hideBuffFades"])) then
			local alarmtype = vexalarm.warning.validate(spellid, caster, eventchar, nil, true)
			if(alarmtype ~="" and alarmtype ~="dejavue") then
				vexalarm.rw.postWarning(alarmtype, spellname, spellid, caster, target, status)				
			end
		end
	end
end

function vexalarm.rw.postWarning(alarmtype, spell, spellid,  caster, target, status)
	local msg = vexalarm.rw.generateText(alarmtype, spell, spellid, caster, target, status)
	if msg~="" then
		vexalarm.rw.generateWarning(alarmtype, spell, spellid, caster, target, status, msg)
	end
end

function vexalarm.rw.generateText(alarmtype, spell, spellid, caster, target, status)
	--load custom msg
	local customalarm = ""
	local statusstring = "inactive"
	if status then statusstring = "active" end
	
	if caster == target and not(vexalarm_SV_rw["msgs"]["misc"]["showTargetwhenCaster"]) then
		if alarmtype == "buffWtarget" 			then alarmtype = "buffWOtarget"
		elseif alarmtype == "castWtarget" 	then alarmtype = "castWOtarget"
		end
	end
	
	if 		alarmtype == "buffWtarget" 		then customalarm = vexalarm_SV_rw["msgs"]["buffWtarget"][statusstring]
	elseif 	alarmtype == "buffWOtarget"	  	then customalarm = vexalarm_SV_rw["msgs"]["buffWOtarget"][statusstring]
	elseif 	alarmtype == "castWtarget" 		then customalarm = vexalarm_SV_rw["msgs"]["castWtarget"]
	elseif 	alarmtype == "castWOtarget" 	then customalarm = vexalarm_SV_rw["msgs"]["castWOtarget"]
	end
	
	--load custom status msg
	local statustext=vexalarm_SV_general["msgs"]["status"][statusstring]
	
	-- change [spell]
	if spellid ~= nil and spell ~= nil then
		local channel = vexalarm.rw.checkChannel()
		if ((channel == "rwOverRide" or (channel == "channel" and vexalarm_SV_rw["warning"]["channel"] == "RAID_WARNING")) and vexalarm_SV_rw["forbidSpelllink"]) or vexalarm_SV_rw["forbidspelllink"] then
			customalarm = string.gsub(customalarm, "%[spell%]", spell)
		else
			customalarm = string.gsub(customalarm, "%[spell%]", GetSpellLink(spellid))
		end
	end
	
	-- change [caster]
	if caster ~= nil then
		caster = vexalarm.rw.convertServernames(caster)
		customalarm = string.gsub(customalarm, "%[caster%]", caster)
	end
	
	-- change [target]
	if target ~= nil then
		target = vexalarm.rw.convertServernames(target)
		customalarm = string.gsub(customalarm, "%[target%]", target)
	end
	
	-- change [statustext]
	if statustext ~= nil then
		customalarm = string.gsub(customalarm, "%[status%]", statustext)
	end
	return customalarm
end

function vexalarm.rw.convertServernames(name)
	if vexalarm_SV_rw["msgs"]["misc"]["showServer"] then
		return name
	else
		if string.find(name, "%-.-$")~=nil then
			name = string.gsub(name, "%-.-$", "")
		end
		return name
	end
end

function vexalarm.rw.checkChannel()
	local channel = ""
	local inRaid = UnitInRaid("player")
	if inRaid and vexalarm_SV_rw["warning"]["rwInRaid"] then
		channel = "rwOverRide"
	elseif not(inRaid) and vexalarm_SV_rw["warning"]["channel"]=="RAID_WARNING" then
		channel = ""
	else
		channel = "channel"
	end
	
	return channel
end

function vexalarm.rw.generateWarning(alarmtype, spell, spellid, caster, target, status, msg)
	if status and vexalarm.defaults.spells[tostring(spellid)][7]~=nil then
		vexalarm.totem.rwCreate(alarmtype, spell, spellid, caster, target)
	end
	
	local channel = vexalarm.rw.checkChannel()
	if channel == "channel" then
		SendChatMessage(msg, vexalarm_SV_rw["warning"]["channel"], nil, vexalarm_SV_rw["warning"]["customChannel"])
	elseif channel == "rwOverRide" then
		SendChatMessage(msg, "RAID_WARNING")
	end		
end







