function vexalarm.panel_rwcontent()
	return {
		type = "group",
		order= 1,
		args = {
			grptestmode = {
				name = "Testmode",
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = "Activate",
						order=1, type = "toggle", width="full",
						set = function(info,val) vexalarm_Testmode_handler(val) end,
						get = function() return vexalarm.testmode end,
						},
					testmodeinfo = {name = "- Simulates Event outputs. The spell/spell-profile adjustments for the frames are still active.\n- Frames become movable\n- Frames and Outputpositions become recolored", type = "description", order=2},
					},
				},
			frame_space_testmode = {name ="\n", type = "description", order=2},
			
			grpoptiontabs = {
				name = "Toggle Option Tabs",
				order=3, type ="group", dialogInline = true,
				args = {
					buffs = {
						name = "Buffs",
						order=1, type = "execute",
						func = function(info,val) vexalarm_optionTab_RWContent_toggleTab("buffs") vexalarm_initialize(true) end,
						},
					selfbuffs = {
						name = "Selfbuffs",
						order=2, type = "execute",
						func = function(info,val) vexalarm_optionTab_RWContent_toggleTab("selfbuffs") vexalarm_initialize(true) end,
						},
					groupbuffs = {
						name = "Groupbuffs",
						order=3, type = "execute",
						func = function(info,val) vexalarm_optionTab_RWContent_toggleTab("groupbuffs") vexalarm_initialize(true) end,
						},
					instants = {
						name = "Casts with targets",
						order=4, type = "execute",
						func = function(info,val) vexalarm_optionTab_RWContent_toggleTab("castswithtargets") vexalarm_initialize(true) end,
						},
					instantsself = {
						name = "Casts without targets",
						order=5, type = "execute",
						func = function(info,val) vexalarm_optionTab_RWContent_toggleTab("castswithouttargets") vexalarm_initialize(true) end,
						},
					status = {
						name = "[status] messages",
						order=6, type = "execute",
						func = function(info,val) vexalarm_optionTab_RWContent_toggleTab("status") vexalarm_initialize(true) end,
						},
					space = {name =" ", type = "description", order=10},
					information = {
						name = "HELP",
						order=12, type = "execute",
						func = function(info,val) vexalarm_TagWindows_toggle(true) end,
						},
					},
				},
			spaceoptiontabs = {name =" ", type = "description", order=4},
				
			grpmsgsbuffs = {
				name = "Buffs",
				order=10, type ="group", dialogInline = true, hidden = not(vexalarm_optionTab_RWContent_openTab["buffs"]),
				args = {
					buffinfo = {name ="Buffs that have a single target\n", type = "description", order=1, fontSize="medium"},
					buffimage = {name=vexalarm_Colorize_class(select(1, GetSpellInfo(47788)), "47788", "spell").." (Example)", fontSize="large",
						image = select(3, GetSpellInfo(47788)), type="description", order=2},
					buff = {
						name = "Buff gained",
						order=10, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_data["rw"]["msgs"]["buff"]["active"]=vexalarm_optionTab_MsgContent_filterTags(vexalarm_optionTab_RWContent_killBadTags(val), "buff") end,
						get = function() return vexalarm_data["rw"]["msgs"]["buff"]["active"] end
						},
					buffdefault = {
						name = "reset to defaults",
						order=11, type = "execute",
						func = function(info,val) vexalarm_data["rw"]["msgs"]["buff"]["active"]=vexalarm_defaults["rw"]["msgs"]["buff"]["active"] end,
						},
					buff2 = {
						name = "Buff lost",
						order=12, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_data["rw"]["msgs"]["buff"]["inactive"]=vexalarm_optionTab_MsgContent_filterTags(vexalarm_optionTab_RWContent_killBadTags(val), "buff") end,
						get = function() return vexalarm_data["rw"]["msgs"]["buff"]["inactive"] end
						},
					buff2default = {
						name = "reset to defaults",
						order=13, type = "execute",
						func = function(info,val) vexalarm_data["rw"]["msgs"]["buff"]["inactive"]=vexalarm_defaults["rw"]["msgs"]["buff"]["inactive"] end,
						},
					},
				},
				
			grpmsgsselfbuffs = {
				name = "Selfbuffs",
				order=20, type ="group", dialogInline = true, hidden = not(vexalarm_optionTab_RWContent_openTab["selfbuffs"]),
				args = {
					selfbuffinfo = {name ="Buffs that have no target and are mostly casted on yourself\n", type = "description", order=1, fontSize="medium"},
					selfbuffimage = {name=vexalarm_Colorize_class(select(1, GetSpellInfo(871)), "871", "spell").." (Example)", fontSize="large",
						image = select(3, GetSpellInfo(871)), type="description", order=2},
					selfbuff = {
						name = "Buff gained",
						order=10, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_data["rw"]["msgs"]["selfbuff"]["active"]=vexalarm_optionTab_MsgContent_filterTags(vexalarm_optionTab_RWContent_killBadTags(val), "selfbuff") end,
						get = function() return vexalarm_data["rw"]["msgs"]["selfbuff"]["active"] end
						},
					selfbuffdefault = {
						name = "reset to defaults",
						order=11, type = "execute",
						func = function(info,val) vexalarm_data["rw"]["msgs"]["selfbuff"]["active"]=vexalarm_defaults["rw"]["msgs"]["selfbuff"]["active"] end,
						},
					selfbuff2 = {
						name = "Buff lost",
						order=12, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_data["rw"]["msgs"]["selfbuff"]["inactive"]=vexalarm_optionTab_MsgContent_filterTags(vexalarm_optionTab_RWContent_killBadTags(val), "selfbuff") end,
						get = function() return vexalarm_data["rw"]["msgs"]["selfbuff"]["inactive"] end
						},
					selfbuff2default = {
						name = "reset to defaults",
						order=13, type = "execute",
						func = function(info,val) vexalarm_data["rw"]["msgs"]["selfbuff"]["inactive"]=vexalarm_defaults["rw"]["msgs"]["selfbuff"]["inactive"] end,
						},
					},
				},
				
			grpmsgsgrpbuffs = {
				name = "Groupbuffs",
				order=30, type ="group", dialogInline = true, hidden = not(vexalarm_optionTab_RWContent_openTab["groupbuffs"]),
				args = {
					grpbuffinfo = {name ="Buffs that effect multiple targets\n", type = "description", order=1, fontSize="medium"},
					grpbuffimage = {name=vexalarm_Colorize_class(select(1, GetSpellInfo(32182)), "32182", "spell").." (Example)", fontSize="large",
						image = select(3, GetSpellInfo(32182)), type="description", order=2},
					grpbuff = {
						name = "Buff gained",
						order=10, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_data["rw"]["msgs"]["grpbuff"]["active"]=vexalarm_optionTab_MsgContent_filterTags(vexalarm_optionTab_RWContent_killBadTags(val), "grpbuff") end,
						get = function() return vexalarm_data["rw"]["msgs"]["grpbuff"]["active"] end
						},
					grpbuffdefault = {
						name = "reset to defaults",
						order=11, type = "execute",
						func = function(info,val) vexalarm_data["rw"]["msgs"]["grpbuff"]["active"]=vexalarm_defaults["rw"]["msgs"]["grpbuff"]["active"] end,
						},
					grpbuff2 = {
						name = "Buff lost",
						order=12, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_data["rw"]["msgs"]["grpbuff"]["inactive"]=vexalarm_optionTab_MsgContent_filterTags(vexalarm_optionTab_RWContent_killBadTags(val), "grpbuff") end,
						get = function() return vexalarm_data["rw"]["msgs"]["grpbuff"]["inactive"] end
						},
					grpbuff2default = {
						name = "reset to defaults",
						order=13, type = "execute",
						func = function(info,val) vexalarm_data["rw"]["msgs"]["grpbuff"]["inactive"]=vexalarm_defaults["rw"]["msgs"]["grpbuff"]["inactive"] end,
						},
					},
				},
				
			grpmsgsinstants = {
				name = "Casts with targets",
				order=40, type ="group", dialogInline = true, hidden = not(vexalarm_optionTab_RWContent_openTab["castswithtargets"]),
				args = {
					castinfo = {name ="Casts that have a target\n", type = "description", order=1, fontSize="medium"},
					castimage = {name=vexalarm_Colorize_class(select(1, GetSpellInfo(34477)), "34477", "spell").." (Example)", fontSize="large",
						image = select(3, GetSpellInfo(34477)), type="description", order=2},
					instant = {
						name = "Message",
						order=10, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_data["rw"]["msgs"]["instant"]=vexalarm_optionTab_MsgContent_filterTags(vexalarm_optionTab_RWContent_killBadTags(val), "instant") end,
						get = function() return vexalarm_data["rw"]["msgs"]["instant"] end
						},
					instantdefault = {
						name = "reset to defaults",
						order=11, type = "execute",
						func = function(info,val) vexalarm_data["rw"]["msgs"]["instant"]=vexalarm_defaults["rw"]["msgs"]["instant"] end,
						},
					},
				},
				
			grpmsgsinstantsself = {
				name = "Casts without targets",
				order=50, type ="group", dialogInline = true, hidden = not(vexalarm_optionTab_RWContent_openTab["castswithouttargets"]),
				args = {
					selfcastinfo = {name ="Casts that have no target and are mostly casted on yourself\n", type = "description", order=1, fontSize="medium"},
					selfcastimage = {name=vexalarm_Colorize_class(select(1, GetSpellInfo(1856)), "1856", "spell").." (Example)", fontSize="large",
						image = select(3, GetSpellInfo(1856)), type="description", order=2},
					instantself = {
						name = "Message",
						order=10, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexalarm_data["rw"]["msgs"]["instantself"]=vexalarm_optionTab_MsgContent_filterTags(vexalarm_optionTab_RWContent_killBadTags(val), "instantself") end,
						get = function() return vexalarm_data["rw"]["msgs"]["instantself"] end
						},
					instantselfdefault = {
						name = "reset to defaults",
						order=11, type = "execute",
						func = function(info,val) vexalarm_data["rw"]["msgs"]["instantself"]=vexalarm_defaults["rw"]["msgs"]["instantself"] end,
						},
					},
				},
			
			grpmsgsstatus = {
				name = "[status] Messages",
				order=60, type ="group", dialogInline = true, hidden = not(vexalarm_optionTab_RWContent_openTab["status"]),
				args = {
					statusinfo = {name ="The content of these tags can be adjusted and parsed into the output messages.", type = "description", order=1, fontSize="medium"},
					activeself = {
						name = "[status] active",
						order=10, type = "input", multiline = false,
						set = function(info,val) vexalarm_data["rw"]["msgs"]["status"]["active"]=vexalarm_optionTab_RWContent_killBadTags(val) end,
						get = function() return vexalarm_data["rw"]["msgs"]["status"]["active"] end
						},
					activedefault = {
						name = "reset to defaults",
						order=11, type = "execute",
						func = function(info,val) vexalarm_data["rw"]["msgs"]["status"]["active"]=vexalarm_defaults["rw"]["msgs"]["status"]["active"] end,
						},
					statusspace = {name ="\n", type = "description", order=12},
						
					inactiveself = {
						name = "[status] inactive",
						order=13, type = "input", multiline = false,
						set = function(info,val) vexalarm_data["rw"]["msgs"]["status"]["inactive"]=vexalarm_optionTab_RWContent_killBadTags(val) end,
						get = function() return vexalarm_data["rw"]["msgs"]["status"]["inactive"] end
						},
					inactivedefault = {
						name = "reset to defaults",
						order=14, type = "execute",
						func = function(info,val) vexalarm_data["rw"]["msgs"]["status"]["inactive"]=vexalarm_defaults["rw"]["msgs"]["status"]["inactive"] end,
						},
					},
				},
			}
		}
end